/*=============================================================================
JCoop5, copyright 2003 by Joss Liu
 17 Jul 2002 original - UPak PlayerClass protections
	07 Aug 2002 added login to full server (push)
	28 Aug 2002 added proper default health handling w/ scaling
	08 Sep 2002 fixed minor bug with armor icon showing in inventory
	16 Sep 2002 begin work on V2
		inventory items now get PickUpFunction called
		fixed minor bug with non-display inventory having empty entry
	20 Sep 2002 fixed spectator announcement bug where would announce in
		prelogin() tho the login later failed. moved announcements
		to postlogin()
	27 Sep 2002 ScoreBoard w/ deaths/kills/score
		fixed many Accessed Nones in ScoreKill, Killed
	04 Oct 2002 fixed bug where 224/225 client using space in name would crash server
		fixed bug with UPakMaleThree always getting FemaleOne
	07 Oct 2002 Score table to maintain player scores to reestablish after
		disconnect, plus added COOP scores, player muting
	11 Oct 2002 Improved scoring to include penalties for suicides & friendly kills
	13 Oct 2002 added timer for map changing. A player must log in at least once
		for timer to count down. Timer disabled if TimeLimit=0. "admin setmaptime x"
		will change the current TimeLimit and reset RemainingTime to the new value.
	15 Oct 2002 added new fix for the buggy endmap.unr (see the fix Epic attempted
		in CoopGame.SendPlayer()
	17 Oct 2002 begin V3
		Added full overrides for allowed playerclasses, now assigned in Login()
		Added AdminTool functions to jPlayerPawn baseclass; moved mute & setmaptime
		to jPlayerPawn
		tweaks to make work...
	20 Oct 2002 Added randomization to teleporter (when multiple endings in map)
		Added Decoration.Contents and Pawn.DropWhenKilled controls.
	23 Oct 2002 custom map timer, summonp, gotop, new jrPassword
	04 Nov 2002 moved Keepout list to PreLogin. No longer uses timer.
	    Added prohibition for rapid logins.
	06 Nov 2002 fixed bug with some player showing ID 0 in scoreboard, but really
	    had a proper ID. Caused by wrong defaultplayerclass w/ reg playerreplicationinfo
	08 Nov 2002 Changed jPlayerPawn subclassing to address problem seen in
		ExtremeDGen where player would not get transported proper to 2nd map area.
		fixed other minor problems with default health, rapid login, CustomMapTimer
		list processing. Finished readme and had it proofed.
	20 Nov 2002 fix problem with some player still getting standard unreali
		playerclass: desiredclass is not unreali.anything, and server sets with std
		playerclass found in user.ini
	24 Nov 2002 begin v4
		moved decorations code to it's own mutator
	02 Dec 2002 in PreLogin(), fixed probelm with null password "?password=" in options
		string will crash client (or even server!) (pointed out by Kaos-ElectricMew)
	29 Dec 2002 added new map ending remapping (code snippet from Zora)
	05 Jan 2003 ending teleporter visibility, advance function to advance maps
		weapon switch in GiveItems, setautoactivate fixed to save properly in user.ini,
		score penalty for cows, removed vestigal variable references, set playerpawn
		airspeed slightly higher than groundspeed
	05 Feb 2003 beginning V5
		remove the sequence remapping and maptimer stuff, moved to it's own actor
	21 Feb 2003
		*** main feature *** added to Logout() to send any melee pawns into waiting state
		removed idlekick from jPlayerPawn (now in separate actor)
		added data structs for say filtering
	12 Mar 2003 added lsay (whisper), make shield follow player
	17 Mar 2003 make lsay can't talk thru walls; change logout to search entire
		pawn list, not just nearby pawns
=============================================================================*/
class jCoopGame extends CoopGame config;

enum EJCmds
{
	JKO_ADD,
	JKO_LIST,
	JKO_CLEAR
};

struct ScoreEntry
{
	var string PlayerName;
	var int EnemyKills;
	var int FriendKills;
	var int Deaths;
	var int Suicides;
	var int Score; // frags
	var bool bMute;
	var float LOTime;
};
var struct Joiners_Type
{
	var string PlayerName;
	var string IPAddress;
} Joiners[50];
struct RealIPAddr
{
	var() config byte Nr1,Nr2,Nr3,Nr4;
	var() config string BannedName;
};

var ScoreEntry			ScoreTable[64];

struct LoginEntry
{
	var string PlayerName;
	var float TimeStamp;
};

var LoginEntry			MRLogin[4]; // most recent logins
var LoginEntry			KeepoutList[8];

var(PlayerControl) config Array<string> GiveItem;
var(PlayerControl) config bool		bAllowSummons; // allow all players to summon
var(PlayerControl) config bool		bSetHealth; // restore health to base at level change
var(PlayerControl) config bool		bKeepScores; // restore player scores at login
var(PlayerControl) config bool		bShowPlayerShots; // names the player that shot you
// default health will be scaled by player type: nali 0.8, human 1.0, skaarj 1.3
var(PlayerControl) config string		newHealthRef; // base health for players (100 normal)
var(PlayerControl) config int		MaxSuicides; // maximum allowable suicides
var(PlayerControl) config bool		bNoSpam; // to stop repeated messages
var(PlayerControl) config float		LoginDenyPeriod; // don't allow relogin during this amount time
var(PlayerControl) config string	RestrictedKeyword[16]; // words restricted from Admin command if tmpAdmin

var(GameControl) config bool		bRespawnAll; // respawn all items in level
var(GameControl) config bool		bShowDownloaders; // show downloaders
var(GameControl) config bool		bShowAdmins; // announce Admin login and show on scoreboard
var(GameControl) config bool		bCoopScore; // show Coop Score on scoreboard
var(GameControl) config bool		bCastFailedLogin; // broadcast login failures to admins
var(GameControl) config bool		bFullSvrLogin; // allow forced login to full server
var(GameControl) private globalconfig string FullSvrPass; // allow logins to a full server
var(GameControl) config bool		bChatLog; // log the "say" messages
var(GameControl) private globalconfig string AdminPassword[4];// Password to receive bAdmin privileges.
var(GameControl) private globalconfig string GamePassword;	// Password to enter game.
var(GameControl) config bool		bAdvLead; // put advertising text at lead or tail
var(GameControl) config RealIPAddr	BannedIPs[50]; // IP's that are banned.

var(Effects) config bool	bShowExtraEffects; // show the effects that SP and listenserver show
var(Effects) config	int		ServerTravelPause;	// >0: active Solo's special view player ending

var	int					EndDelayTimer;
var bool				bDontEnd;
var string				NextGameURL;
var localized string	GlobalNameChange;
var localized string	NoNameChange;
var localized string	TimeMessage[16];
var int					iBaseHealth;
var string				RapidLoginMessage;
var string				KeepoutMessage;
var string				NoNameMessage;
var string				AdvJC;
var float				endMsgTime;
var int					endMsgCount;
var int					LastJoin;
var float 				ReCheckDLers;
var bool				bHasReported;

var Actor				Helper;

//=============================================================================
function PreBeginPlay()
{
	local int i;

	super.PreBeginPlay();

	endMsgTime = 0;
	endMsgCount = 0;
	if(ServerTravelPause <= 0) ServerTravelPause = 0;

	// coerce server to generate the extra cool effects missing in dedicated server
	if(bShowExtraEffects)
		if(Level.NetMode == NM_DedicatedServer)
			Level.NetMode = NM_ListenServer;

	// clear the most recent login list
	for(i=0; i<ArrayCount(MRLogin); i++)
	{
		MRLogin[i].PlayerName = "";
		MRLogin[i].TimeStamp = 0;
	}

} // PreBeginPlay()

function PostBeginPlay()
{
	local int i;
//	local class<Actor> cA;
//	local PlrFnc A;

	super(UnrealGameInfo).PostBeginPlay();

	iBaseHealth = int (NewHealthRef);
	if(iBaseHealth == 0) iBaseHealth = 100;

	// log a banner
	log("======================================================================================", 'JCoop');
	log("JCoop v5.0 copyright 2003 by Joss Liu j88oss@yahoo.com www.geocities.com/j88oss", 'JCoop');
	log("Original coding by Joss Liu, September 2002 - March 2003", 'JCoop');
	log("Special thanks to: Maniac, Cherokee, Teela, (DarkSW)Wolf", 'JCoop');
	log("     Zora, Zombie, digital zynthetic, Koopa888, }TCP{Wolf - for ideas and feedback making JCoop better game", 'JCoop');
	log("======================================================================================", 'JCoop');
	log("Current password settings:", 'JCoop');
	for(i = 0; i < ArrayCount(AdminPassword); i++)
		log("AdminPassword["$i$"]:"$AdminPassword[i], 'JCoop');
	log("GamePassword:"$GamePassword, 'JCoop');
log("BotMenuType" @ BotMenuType @ "Default:" $ Default.BotMenuType, 'jCoop');
} // PostBeginPlay()

function InitGameReplicationInfo()
{
	local int i;

	super.InitGameReplicationInfo();
	// force to show in the Coop Game browser tab
	GameName = "Coop Game";

	JCGRI(GameReplicationInfo).bShowAdmins = bShowAdmins;
	JCGRI(GameReplicationInfo).bCoopScore = bCoopScore;
	i = InStr(caps(GameReplicationInfo.ServerName), caps(AdvJC));
	if(i == -1)
		if(bAdvLead)
			GameReplicationInfo.ServerName = AdvJC @ GameReplicationInfo.ServerName;
		else
			GameReplicationInfo.ServerName = GameReplicationInfo.ServerName @ AdvJC;
} // InitGameReplicationInfo()

function RestartGame() { /* do nothing... */ }

// the Teleporter calls this one...
function SendPlayer( PlayerPawn aPlayer, string URL )
{
	local int i;
	local string reason;
	local pawn P;
	local actor A;
	local int NumberKilled;
	local float CurrentProcent;
	

	if(bDontEnd) // administratively set to prevent level ending
	{
		if(((Level.TimeSeconds - endMsgTime) > 10.0) && (endMsgCount < 10))
		{
			endMsgCount ++;
			if(aPlayer != none)
			{
				aPlayer.ClientMessage("This map ending is currently disabled by admin");
				Amsg(aPlayer.PlayerReplicationInfo.PlayerName @ "hit the ending");
			}
			endMsgTime = Level.TimeSeconds;
		}
		return;
	}
	if(bGameEnded)
	{
		log("game already ended - rejecting " $ URL, 'JCoop');
	    return ;
	}

	bGameEnded = True;
	if(aPlayer != None)
		reason = aPlayer.PlayerReplicationInfo.PlayerName @ "ended the level";
	else
		reason = "server or admin ended the level";
	log(reason, 'JCoop');
	BroadcastMessage(reason, false);

	// default: next map is given
	NextGameUrl = URL;

	foreach AllActors(class'Actor', A, 'EndGame')
		A.trigger(self, none);

	for(P = Level.PawnList; P != None; P = P.NextPawn )
	{
		P.ClientGameEnded(); // make the pawns quit hammering players
		if(P.bIsPlayer)
		{
			if(P != aPlayer)
			{
				P.GotoState('GameEnded');
				PlayerPawn(P).ViewTarget = aPlayer;
			}
		}
	}
}
function JoinersRequest( bool bIsJoining, optional string PName, optional string PIP, optional out RealIPAddr IPs )
{
	local int i,Tries;
	local string SplitIP;
	
	if( bIsJoining )
	{
		for (i = 0; i< ArrayCount(Joiners); i++)
		{
			if( Joiners[i].PlayerName~=PName )
			{
				Joiners[i].IPAddress = PIP;
				Return;
			}
		}
		Joiners[LastJoin].PlayerName = PName;
		Joiners[LastJoin].IPAddress = PIP;
		LastJoin++;
		if( LastJoin>=ArrayCount(Joiners) )
			LastJoin=0;
	}
	else
	{
		i = LastJoin+1;
		while( Tries<=52 && Joiners[i].PlayerName!=PName )
		{
			Tries++;
			i--;
			if( i<0 )
				i = ArrayCount(Joiners)-1;
		}
		if( Joiners[i].PlayerName!=PName )
		{
			IPs.Nr1 = 255;
			IPs.Nr2 = 255;
			IPs.Nr3 = 255;
			IPs.Nr4 = 255;
		}
		else
		{
			SplitIP = Joiners[i].IPAddress;
			IPs.Nr1 = int(Left(SplitIP,InStr(SplitIP, ".")));
			SplitIP = Mid(SplitIP,InStr(SplitIP, ".")+1);
			IPs.Nr2 = int(Left(SplitIP,InStr(SplitIP, ".")));
			SplitIP = Mid(SplitIP,InStr(SplitIP, ".")+1);
			IPs.Nr3 = int(Left(SplitIP,InStr(SplitIP, ".")));
			SplitIP = Mid(SplitIP,InStr(SplitIP, ".")+1);
			IPs.Nr4 = int(SplitIP);
		}
	}
}
// add a name to keepout list
function KeepoutListCtrl(EJCmds c, optional string playername)
{
	local int i, oldest;
	switch(c)
	{
		case JKO_LIST:
			for(i=0; i<ArrayCount(KeepoutList); i++)
				if(KeepoutList[i].PlayerName != "")
				{
					AMsg("KeepoutList["$i$"] -"@KeepoutList[i].PlayerName);
				}
			break;
		case JKO_CLEAR:
			for(i=0; i<ArrayCount(KeepoutList); i++)
				KeepoutList[i].PlayerName = "";
			break;
		case JKO_ADD:
			for(i=0; i<ArrayCount(KeepoutList); i++)
			{
				if(KeepoutList[i].PlayerName == "")
				{
					KeepoutList[i].PlayerName = playername;
					KeepoutList[i].TimeStamp = Level.TimeSeconds;
					break;
				}
			}
			if(i == ArrayCount(KeepoutList)) // array full, so replace oldest
			{
				for(i=0; i<ArrayCount(KeepoutList); i++)
					if(KeepoutList[i].TimeStamp < KeepoutList[oldest].TimeStamp)
						oldest = i;
				KeepoutList[oldest].PlayerName = playername;
				KeepoutList[oldest].TimeStamp = Level.TimeSeconds;
			}
			break;
		default:
			AMsg("Keepout ERROR - bad command");
			break;
	}
}

// called by jPlayerPawn.Admin & jPlayerPawn.summon for restricted keywords
function bool AllowCmd(string CmdLine)
{
	local int i;
	for(i = 0; i < ArrayCount(RestrictedKeyword); i++)
	{
		if(RestrictedKeyword[i] != "")
			if(Instr(caps(CmdLine), caps(RestrictedKeyword[i])) != -1)
				return false;
	}
	return true;
}

function Timer()
{
	super.Timer();
	JCGRI(GameReplicationInfo).GameTime ++;

	if(NextGameUrl != "")
	{
		EndDelayTimer++;
		if(EndDelayTimer >= ServerTravelPause)
		{
			log("jCoopGame.Timer() doing ServerTravel to" @ NextGameUrl, 'JCoop');
			Level.ServerTravel(NextGameUrl, true);
		}
		return;
	}
} // Timer()

function AddDefaultInventory(Pawn p)
{
	if(!p.IsA('jPlayerPawn')) return;
	if(p.IsA('jSpectator')) return;
	super.AddDefaultInventory(p);
	GiveItems(p); // the extra configurable inventories
	if(bSetHealth)
	{
		if(p.IsA('jNaliPlayer'))			// default 80
		{
			if(p.Health < 0.8 * iBaseHealth)
				p.Health = 0.8 * iBaseHealth;
			if(p.Health > 2.0 * 0.8 * iBaseHealth)
				p.Health = 2.0 * 0.8 * iBaseHealth;
		}
		else if(p.IsA('jHuman'))			// default 100
		{
			if(p.Health < 1.0 * iBaseHealth)
				p.Health = 1.0 * iBaseHealth;
			if(p.Health > 2.0 * 1.0 * iBaseHealth)
				p.Health = 2.0 * 1.0 * iBaseHealth;
		}
		else if(p.IsA('jSkaarjPlayer'))		// default 130
		{
			if(p.Health < 1.3 * iBaseHealth)
				p.Health = 1.3 * iBaseHealth;
			if(p.Health > 2.0 * 1.3 * iBaseHealth)
				p.Health = 2.0 * 1.3 * iBaseHealth;
		}
	}
} // AddDefaultInventory()

function GiveItems(Pawn p)
{
	local string ItemsToGive;
	local string nextItem;
	local class<Inventory> InvClass;
	local Inventory InvGive, InvHeld;
	local int HealMax;
	local DispersionPistol d;

	if(p==None || p.isa('bot')) return; // ignore bots

	ItemsToGive = GetPropertyText("GiveItem");
	ItemsToGive = Mid(ItemsToGive, 1, Len(ItemsToGive) - 2);

	//traverse the list, spawning and giving items...
	while(gobble(nextItem, ItemsToGive))
	{
		// search for the dot
		if(InStr(nextItem, ".") == -1)
			nextItem = "unreali."$nextItem;
		InvClass = class<Inventory>(DynamicLoadObject(nextItem, class'Class'));
		if(InvClass != none)
		{
			InvGive = spawn(InvClass);
			if(InvGive == none)
			{
				log("*** ERROR *** failed to spawn"@nextItem, 'JCoop');
				continue; // spawn failure
			}
			InvGive.RespawnTime = 0; // so won't respawn/leave copy at level origin

			InvHeld = p.FindInventoryType(InvGive.class);
			if(InvHeld != none) // already got one
			{
				if(InvGive.IsA('Pickup') && Pickup(InvGive).bCanHaveMultipleCopies)
					Pickup(InvHeld).NumCopies ++;
				else if(InvGive.IsA('Ammo'))
				{
					Ammo(InvHeld).AddAmmo(Ammo(InvGive).AmmoAmount);
				}
				else if(InvGive.IsA('Weapon'))
				{
					if(Weapon(InvGive).AmmoName != none)
					{
						Ammo(p.FindInventoryType(Weapon(InvGive).AmmoName)).AddAmmo(Weapon(InvGive).PickupAmmoCount);
					}
				}
				else
					InvHeld.charge = InvGive.default.charge;

				InvGive.Destroy();
			} // don't have already, check special cases
			else if(InvGive.IsA('Health'))
			{
				HealMax = p.default.Health;
				if(Health(InvGive).bSuperHeal) HealMax *= 2;
				p.Health += Health(InvGive).HealingAmount;
				if(p.Health > HealMax) p.Health = HealMax;
				InvGive.Destroy();
			}
			// bug: player can't shoot or change weps after getting the 4th weaponpowerup :(
			else if(InvGive.IsA('WeaponPowerUp'))
			{
				// Level.Game.PickupQuery(p, InvGive);
				InvGive.Destroy();
			}
			else if(InvGive.IsA('Ammo') && Ammo(InvGive).parentammo != none)
			{
				InvHeld = p.FindInventoryType(Ammo(InvGive).parentammo);
				if(InvHeld != none)
					Ammo(InvHeld).AddAmmo(Ammo(InvGive).AmmoAmount);
				else
					InvGive.SpawnCopy(p);
			}
			else // default action to give a new one
			{
				InvGive.SpawnCopy(p);
				if(InvGive.IsA('Pickup'))
				{
					if(InvGive.bActivatable && Pickup(InvGive).bAutoActivate && p.bAutoActivate)
						InvGive.Activate();
					p.ClientMessage(InvGive.PickupMessage, 'Pickup');
					p.PlaySound(InvGive.PickupSound,,2.0);
					Pickup(InvGive).PickupFunction(p);
				}
				if(InvGive.IsA('Weapon'))
					p.SwitchToBestWeapon();
//				InvGive.Charge = InvGive.default.Charge;
			}
		}
		else
			log("*** ERROR *** Item failed to load properly:<"$nextItem$
				"> Check your GiveItem list", 'JCoop');
	}
}

// Return false if no more items, else true there is more to get from comma delimited
// list. next is the first item found in ItemList, ItemList is shortened
function bool gobble(out string next, out string ItemList)
{
	local int i;
	if(ItemList == "") return false;
	i = Instr(ItemList, ",");
	if(i == -1)
	{
		next = ItemList;
		ItemList = "";
	}
	else
	{
		next = Left(ItemList, i);
		ItemList = Right(ItemList, Len(ItemList) - i - 1);
	}
	return true;
} // gobble()

function bool ShouldRespawn(Actor Other)
{
	if(bRespawnAll) // extended respawning
	{
		if((Other.IsA('Inventory') && !Inventory(Other).bHeldItem &&
			Inventory(Other).RespawnTime != 0))
		{
//			if(Other.IsA('WeaponPowerUp'))
//				Inventory(Other).ReSpawnTime = Inventory(Other).default.ReSpawnTime;
//			else
				Inventory(Other).ReSpawnTime = 1.0;
			return true;
		}
		return false;
	}
	else // normal respawning
		return super.ShouldRespawn(Other);
} // ShouldRespawn()

// Override the GameInfo.PreLogin()
// special key/value pair to allow login to full server
function PreLogin(string Options, out string Error)
{
	local Pawn p;
	local string InPassword;
	local string InName,IPAddr,BlockedIP;
	local int i, oldest;
	local float lp;
	local bool bMRLfull, bLetMeIn, bPendingAdmin;

	Error="";
	InName = ParseOption(Options, "Name");
	IPAddr = GetLastIP();

	Log(InName@"join request ("$IPAddr$")",'PreLogin');
	if( (InPassword~=AdminPassword[0] && AdminPassword[0]!="") || 
	(InPassword~=AdminPassword[1] && AdminPassword[1]!="") || 
	(InPassword~=AdminPassword[2] && AdminPassword[2]!="") || 
	(InPassword~=AdminPassword[3] && AdminPassword[3]!="") )
		AllAMsg("Join request"@Options);
	else AMsg("Join request"@Options);
	if(InName == "")
	{
		Error = NoNameMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return;
	}

	// perform keepout checking
	for(i=0; i<ArrayCount(KeepoutList); i++)
	{
		if(InName ~= KeepoutList[i].PlayerName)
		{
			Error = KeepoutMessage;
			if(bCastFailedLogin)
				AMsg(InName@"failed login:"@"("$Error@":"$IPAddr$")");
			return;
		}
	}
	for(i=0; i<ArrayCount(BannedIPs); i++)
	{
		if( BannedIPs[i].Nr1!=0 || BannedIPs[i].Nr2!=0 || BannedIPs[i].Nr3!=0 || BannedIPs[i].Nr4!=0 )
		{
			BlockedIP = BannedIPs[i].Nr1$"."$BannedIPs[i].Nr2$"."$BannedIPs[i].Nr3$"."$BannedIPs[i].Nr4;
			if(BlockedIP ~= IPAddr)
			{
				Error = KeepoutMessage;
				if(bCastFailedLogin)
					AMsg(InName@"failed login:"@"("$Error@":"$IPAddr$")");
				return;
			}
		}
	}
	JoinersRequest(True,InName,IPAddr);
	// prevent rapid logins (after the initial 'rush' of logins when level changes
	// check if in list ....
	if((Level.TimeSeconds > 90) && (LoginDenyPeriod != 0))
	{
		for(i=0; i<ArrayCount(MRLogin); i++)
			if(InName ~= MRLogin[i].PlayerName)
			{
				lp = Level.TimeSeconds - MRLogin[i].TimeStamp;
				// even this gets cleared in prebeginplay, still sometimes the
				// player can have a timestamp > level.timeseconds... usually very
				// much bigger, as if it lingers from the previous level
				if(lp < 0)
					lp *= -1;
				if(lp < LoginDenyPeriod)
				{
log("******** rapid login alert ********", 'JCoop');
log("Name:"$InName@"saved name:"$MRLogin[i].PlayerName, 'JCoop');
log("ServerTime:"$Level.TimeSeconds@"login timestamp:"$MRLogin[i].TimeStamp@"Difference:"$lp, 'JCoop');
log("******** rapid login alert ********", 'JCoop');
					Error = RapidLoginMessage$LoginDenyPeriod@"seconds delay";
					if(bCastFailedLogin)
						AMsg(InName@"failed login:"@"("$Error$")");
					return;
				}
			}
	}

	// then add to list....
	bMRLfull = true;
	for(i=0; i<ArrayCount(MRLogin); i++)
		if(MRLogin[i].PlayerName == "" || MRLogin[i].PlayerName ~= InName)
		{
			MRLogin[i].PlayerName = InName;
			MRLogin[i].TimeStamp = Level.TimeSeconds;
			bMRLfull = false;
			break;
		}
	oldest = 0;
	if(bMRLfull) // array full, so replace oldest
	{
		for(i=0; i<ArrayCount(MRLogin); i++)
			if(MRLogin[i].TimeStamp < MRLogin[oldest].TimeStamp)
				oldest = i;
		MRLogin[oldest].PlayerName = InName;
		MRLogin[oldest].TimeStamp = Level.TimeSeconds;
	}

	// Force login to full server?
	if(HasOption(Options, "FullSvrPass"))
		if(bFullSvrLogin && FullSvrPass != "")
		{
			InPassword = ParseOption(Options, "FullSvrPass");
			if(InPassword == "")
				Error = "Invalid FullSvrPass";
			else
			{
				i = InStr(InPassword, "#");
				if(i != -1)
					InPassword = Left(InPassword, i);
				if(caps(InPassword) == caps(FullSvrPass))
					bLetMeIn = true;
				else
					Error = "Invalid FullSvrPass";
			}

			if(bCastFailedLogin && Error != "")
			{
				AMsg(InName@"failed login:"@"("$Error$")");
				return;
			}
		}

	// from GameInfo.PreLogin() - molested
	// check for full server
	if( (Level.NetMode != NM_Standalone) && (MaxPlayers>0) && (NumPlayers>=MaxPlayers) )
		if(!bLetMeIn)
		{
			Error=MaxedOutMessage;
			if(bCastFailedLogin)
				AMsg(InName@"failed login:"@"("$Error$")");
			return;
		}

	// now check passwords
	InPassword = ParseOption(Options, "Password");
	bLetMeIn = false;
	if(HasOption(Options, "Password") && InPassword == "")
		Error = "Null password not valid. Either use a non-null password, or remove ?password=";
	else
	{
		bPendingAdmin = false;
		for(i = 0; i < ArrayCount(AdminPassword); i++)
		{
			if(AdminPassword[i] == "")
				continue;
			else
			if(caps(InPassword)==caps(AdminPassword[i]))
			{
				bPendingAdmin = True;
				break;
			}
		}
		if(!bPendingAdmin && GamePassword!="" && caps(InPassword)!=caps(GamePassword))
			if( InPassword == "" )
				Error = NeedPassword;
			else
				Error = WrongPassword;
	}

	// post errors to playing Admins (does't show version mismatch errors)
	if(bCastFailedLogin && Error !="")
		AMsg(InName@"failed login:"@"("$Error@":"$IPAddr$")");
	else
		AMsg(InName@"may join ("$IPAddr$")");
	if(Error != "")
		log(Options, 'JCoop');
	ReCheckDLers = 4;
} // PreLogin()
// Check IP from last login()
function string GetLastIP()
{
	local string S;
	
	S = ConsoleCommand("Sockets");
	while( InStr(S, "Client ") >= 0 )
	{
		S = Mid(S,InStr(S, "Client ")+7);
		if( InStr(S, "Client ") < 0 )
			Return Left(S,InStr(S, " "));
	}
}
//=============================================================================
// player class protection, convert all playerclass to equivalent jplayerpawn class
// dissallow UPak/camera(eye,pawn), making sane substitutions for players choice
// 17 July 2002
// works with no references outside unreali/unrealshare so 224f/225f clients
// should have no problems
// -joss
//
// Thanks to digital Zynthetic for ideas in UnEx1 used in Login() function
//=============================================================================

event PlayerPawn Login( string Portal,
						string Options,
						out string Error,
						class<PlayerPawn> SpawnClass)
{
	local NavigationPoint	StartSpot;
	local PlayerPawn		newPlayer, TestPlayer;
	local Pawn				PawnLink;
	local string			InName, InPassword, InSkin, InFace;
	local string			DesiredClass; // player's desired class
	local byte				InTeam;
	local int				i;

	local string			tmpPlayerName, tmpTeamName;
	local int				tmpID;
	local byte				tmpTeam;
	local int				tmpTeamID;
	local class<VoicePack>	tmpVoiceType;
	local bool				tmpbIsABot, tmpbIsSpectator, bLetMeIn;
	local texture			tmpTalkTexture;
	local ZoneInfo			tmpPlayerZone;
	local RealIPAddr		tmpIP;
	local string			ConvertedIP;

	// Make sure there is capacity. (This might have changed since the PreLogin call).
	InPassword = ParseOption(Options, "FullSvrPass");
	if(bFullSvrLogin &&
			FullSvrPass != "" &&
			caps(InPassword) == caps(FullSvrPass))
		bLetMeIn = true;

	if((Level.NetMode != NM_Standalone) && (MaxPlayers>0) && (NumPlayers>=MaxPlayers) && !bLetMeIn)
	{
		Error = MaxedOutMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}

	// Get URL options.
	InName     = Left(ParseOption ( Options, "Name"), 20);
	InTeam     = GetIntOption( Options, "Team", 255 ); // default to "no team"
	InPassword = ParseOption ( Options, "Password" );
	InSkin	   = ParseOption ( Options, "Skin"    );
	InFace     = ParseOption ( Options, "Face"    );

	log("Login:" @ InName, 'JCoop');
	if(InPassword != "")
		log("Password"@InPassword, 'JCoop');

	/*	224/225 is capable of sending an Options string with spaces. Gold seems to
		forbid such, and presumably so does 226f patch. The Gold server somehow
		truncates the Options string at the first space, and then crashes on the
		shortened Options string (seen in my gold log:
		DevNet: Level server received: LOGIN RESPONSE=-667909588 URL=Index.unr?Name=bill gates?Class=UnrealShare.MaleThree?Skin=Male3Skins.Dante?Team=255?Face=
		DevNet: Login request: Index.unr?Name=bill
		After this the server crashes. We will examine the Options string and
		provide some sane fillers for missing parts that might make engine crash.
	*/

	// Assuming at least "?Name=xxxx"
	if(!HasOption(Options,"class"))
	{
		log("Login(): Player has no PlayerClass, giving DefaultPlayerClass.", 'JCoop');
		Options=Options$"?Class="$DefaultPlayerClass.Name;
		SpawnClass = DefaultPlayerClass;
	}
	// LOL! This next line will crash game if ?Class=something is not in Options
	DesiredClass = Left(ParseOption(Options, "Class"), 30);
	i = InStr(DesiredClass, ".");
	if(i != -1)
		DesiredClass = Mid(DesiredClass, i+1);

	// entering playerclass that is not allowed
	if(!ClassIsChildOf(SpawnClass, class'UnrealIPlayer') &&
		!ClassIsChildOf(SpawnClass, class'UnrealSpectator'))
	{
		// not a ChildOf(playerpawn)... so just kick. really should never get here!
		log("Player:"$InName@"trying to use:"$SpawnClass, 'JCoop');
		Error = "Player attmepting use of non-PlayerPawn class: kicked";
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}

	if(DesiredClass ~= (string(SpawnClass.name)))
	{
		if((DesiredClass ~= "UPakFemaleOne") || (DesiredClass ~= "FemaleOne"))
			SpawnClass = class'jFemaleOne';
		else if((DesiredClass ~= "UPakFemaleTwo") || (DesiredClass ~= "FemaleTwo"))
			SpawnClass = class'jFemaleTwo';
		else if((DesiredClass ~= "UPakMaleOne") || (DesiredClass ~= "MaleOne"))
			SpawnClass = class'jMaleOne';
		else if((DesiredClass ~= "UPakMaleTwo") || (DesiredClass ~= "MaleTwo"))
			SpawnClass = class'jMaleTwo';
		else if((DesiredClass ~= "UPakMaleThree") || (DesiredClass ~= "MaleThree"))
			SpawnClass = class'jMaleThree';
		else if(DesiredClass ~= "SkaarjPlayer")
			SpawnClass = class'jSkaarjPlayer';
		else if(DesiredClass ~= "naliplayer")
			SpawnClass = class'jNaliPlayer';
		else if(DesiredClass ~= "UnrealSpectator")
			SpawnClass = class'jSpectator';
		else
			SpawnClass = DefaultPlayerClass;
	}
	else // DesiredClass doesn't match SpawnClass
	{
		if(DesiredClass ~= "UPakFemaleOne")
			SpawnClass = class'jFemaleOne';
		else if(DesiredClass ~= "UPakFemaleTwo")
			SpawnClass = class'jFemaleTwo';
		else if(DesiredClass ~= "UPakMaleOne")
			SpawnClass = class'jMaleOne';
		else if(DesiredClass ~= "UPakMaleTwo")
			SpawnClass = class'jMaleTwo';
		else if(DesiredClass ~= "UPakMaleThree")
			SpawnClass = class'jMaleThree';
		else
			SpawnClass = DefaultPlayerClass;
	}

	log("Incoming Player named"@InName@"desired"@DesiredClass@"and got"@SpawnClass.name, 'JCoop');

	// anything at this point is a legal Unreali/UnrealShare class
// =============================================================================
//		newPlayer = Super.Login(Portal, Options, Error, SpawnClass);
// GameInfo.Login() stuff, molested... this is why we need our own AdminPassword
// and GamePassword, since they are defined as private in GameInfo

	// Find a start spot.
	StartSpot = FindPlayerStart(inteam, Portal);

	if(StartSpot == None)
	{
		Error = FailedPlaceMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}
/* hmmmm.... this block was commented out for jcoop3 & 4 */
	// Try to match up to existing unoccupied player in level,
	// for savegames and coop level switching.
	for( PawnLink=Level.PawnList; PawnLink!=None; PawnLink=PawnLink.NextPawn )
	{
		TestPlayer = PlayerPawn(PawnLink);
		if
		(TestPlayer != None && TestPlayer.Player == None )
		{
			if
			((Level.NetMode == NM_Standalone) ||
			(TestPlayer.PlayerReplicationInfo.PlayerName ~= InName &&
			TestPlayer.Password ~= InPassword))
			{
				// Found matching unoccupied player, so use this one.
				NewPlayer = TestPlayer;
				break;
			}
		}
	}
/* end block comment -- for jcoop5 testing */

	// In not found, spawn a new player.
	if(NewPlayer == none)
	{
		// Make sure this kind of player is allowed.
		if((bHumansOnly || Level.bHumansOnly) && !SpawnClass.Default.bIsHuman &&
				!ClassIsChildOf(SpawnClass, class'Spectator'))
			SpawnClass = DefaultPlayerClass;

		if((NumSpectators >= MaxSpectators) &&
			ClassIsChildOf(SpawnClass, class'Spectator'))
		{
			Error="Max spectators exceeded";
			if(bCastFailedLogin)
				AMsg(InName@"failed login:"@"("$Error$")");
			return None;
		}

		NewPlayer = Spawn(SpawnClass,,,StartSpot.Location,StartSpot.Rotation);
		if( NewPlayer!=None )
			NewPlayer.ViewRotation = StartSpot.Rotation;
	}

	// Handle spawn failure.
	if(NewPlayer == None)
	{
		log("Couldn't spawn player at "$StartSpot, 'JCoop');
		log("Login() -- newPlayer=None", 'JCoop');
		Error = FailedSpawnMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}
	if(!NewPlayer.IsA('jPlayerPawn') && !NewPlayer.IsA('jSpectator')) // does this ever happen?
	{
		NewPlayer.Destroy();
		Error = "Not proper playerclass (not jPlayerPawn or not jSpectator)! Please try again.";
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return none;
	}
	else if(JCPRI(NewPlayer.PlayerReplicationInfo) == none)
	{
		log("Player entered without JCPRI!", 'JCoop');
		// somehow didn't get the right PRI (see this rarely...) so give a new one
		// get my new JCPRI PlayerReplcationInfo extension
		if(newPlayer.PlayerReplicationInfo == none)
		{
			// no PRI at all?
			Error = "No PRI at all! Please try again.";
			if(bCastFailedLogin)
				AMsg(InName@"failed login:"@"("$Error$")");
			NewPlayer.Destroy();
			return none;
		}
		else
		{
			// save the regular PRI info
			tmpPlayerName = newPlayer.PlayerReplicationInfo.PlayerName;
			tmpTeamName = newPlayer.PlayerReplicationInfo.TeamName;
			tmpID = newPlayer.PlayerReplicationInfo.PlayerID;
			tmpTeam = newPlayer.PlayerReplicationInfo.Team;
			tmpTeamID = newPlayer.PlayerReplicationInfo.TeamID;
			tmpVoiceType = newPlayer.PlayerReplicationInfo.VoiceType;
			tmpbIsABot = newPlayer.PlayerReplicationInfo.bIsABot;
			tmpbIsSpectator = newPlayer.PlayerReplicationInfo.bIsSpectator;
			tmpTalkTexture = newPlayer.PlayerReplicationInfo.TalkTexture;
			tmpPlayerZone = newPlayer.PlayerReplicationInfo.PlayerZone;

			// get rid of old PRI and spawn a new JCPRI
			newPlayer.PlayerReplicationInfo.Destroy();
			newPlayer.PlayerReplicationInfo = spawn(class'JCPRI', newPlayer);
			newPlayer.PlayerReplicationInfoClass = class'JCPRI';

			// restore the PRI values to JCPRI
			newPlayer.PlayerReplicationInfo.PlayerName = tmpPlayerName;
			newPlayer.PlayerReplicationInfo.TeamName = tmpTeamName;
			newPlayer.PlayerReplicationInfo.PlayerID = tmpID;
			JCPRI(newPlayer.PlayerReplicationInfo).PlayerID = tmpID;
			newPlayer.PlayerReplicationInfo.Team = tmpTeam;
			newPlayer.PlayerReplicationInfo.TeamID = tmpTeamID;
			newPlayer.PlayerReplicationInfo.VoiceType = tmpVoiceType;
			newPlayer.PlayerReplicationInfo.bIsABot = tmpbIsABot;
			newPlayer.PlayerReplicationInfo.bIsSpectator = tmpbIsSpectator;
			newPlayer.PlayerReplicationInfo.TalkTexture = tmpTalkTexture;
			newPlayer.PlayerReplicationInfo.PlayerZone = tmpPlayerZone;
			JCPRI(newPlayer.PlayerReplicationInfo).bAdmin = newPlayer.bAdmin;
		}
	} // PRI replacement

//		if(InSkin != "")
	NewPlayer.static.SetMultiSkin(NewPlayer, InSkin, InFace, InTeam);

	if(!ChangeTeam(newPlayer, InTeam))
	{
		Error = FailedTeamMessage;
		if(bCastFailedLogin)
			AMsg(InName@"failed login:"@"("$Error$")");
		return None;
	}

	if(NewPlayer.IsA('Spectator') && (Level.NetMode == NM_DedicatedServer))
		NumSpectators++;

	// Init player's administrative privileges
	// new: 2 admin levels - TmpAdmin, Admin. bAdmin is set for both levels
	// TmpAdmin has some restrictions
	NewPlayer.Password = InPassword;
	for(i = 0; i < ArrayCount(AdminPassword); i++)
		if(AdminPassword[i] != "" && caps(InPassword) == caps(AdminPassword[i]))
		{
			NewPlayer.bAdmin = true;
			break;
		}
	if(NewPlayer.bAdmin && i!=0)
		jPlayerPawn(NewPlayer).bTmpAdmin = true;

	if( NewPlayer.bAdmin )
		log("Administrator logged in", 'JCoop');
	if(jPlayerPawn(newPlayer).bTmpAdmin)
		log("*** Temp Admin ***", 'JCoop');

	// Init player's information.
	NewPlayer.ClientSetRotation(NewPlayer.Rotation);

	// Set the player's ID.
	NewPlayer.PlayerReplicationInfo.PlayerID = CurrentID++;
	JCPRI(newPlayer.PlayerReplicationInfo).PlayerID =
		newPlayer.PlayerReplicationInfo.PlayerID;

	if(InName=="" || InName~=defaultPlayerName)
		InName=DefaultPlayerName$newPlayer.PlayerReplicationInfo.PlayerID;
	if(Level.NetMode!=NM_Standalone ||
			NewPlayer.PlayerReplicationInfo.PlayerName~=DefaultPlayerName )
		ChangeName(NewPlayer, InName, false);

	// Init player's replication info
	NewPlayer.GameReplicationInfo = GameReplicationInfo;

	// If we are a server, broadcast a welcome message.
	if( Level.NetMode==NM_DedicatedServer || Level.NetMode==NM_ListenServer )
		BroadcastMessage( NewPlayer.PlayerReplicationInfo.PlayerName$EnteredMessage, false );

	// Teleport-in effect.
	StartSpot.PlayTeleportEffect( NewPlayer, true );

	// Log it.
	if ( LocalLog != None )
		LocalLog.LogPlayerConnect(NewPlayer);
	if ( WorldLog != None )
		WorldLog.LogPlayerConnect(NewPlayer);

// =============================================================================
// CoopGame.Login() stuff, molested
	if(!NewPlayer.IsA('Spectator'))
	{
		NumPlayers++;
		NewPlayer.bHidden = false;
		NewPlayer.SetCollision(true,true,true);
	}
	log("Logging in to "$Level.Title, 'JCoop');
	if(Level.Title ~= "The Source Antechamber")
	{
		bSpecialFallDamage = true;
		log("reduce fall damage", 'JCoop');
	}
	JoinersRequest(False,InName,,tmpIP);
	ConvertedIP = tmpIP.Nr1$"."$tmpIP.Nr2$"."$tmpIP.Nr3$"."$tmpIP.Nr4;
	jPlayerPawn(NewPlayer).ConvertMyIP(ConvertedIP);
	AMsg(InName$"'s IP is"@ConvertedIP);
	return newPlayer;
} // Login()

simulated event PostLogin(PlayerPawn p)
{
	local int i;
	local bool bInTable;

	// make an announcement about player logging in
	if(bShowAdmins && p.bAdmin)
		broadcastmessage(p.PlayerReplicationInfo.PlayerName@"is Admin");
	if(p.IsA('Spectator'))
		broadcastmessage(p.PlayerReplicationInfo.PlayerName@"is spectating");

	// see if we have a score table entry for this player
	i=0;
	while(ScoreTable[i].PlayerName != "" && i<ArrayCount(ScoreTable))
	{
		if(p.PlayerReplicationInfo.PlayerName == ScoreTable[i].PlayerName)
		{
			bInTable = true;
			JCPRI(p.PlayerReplicationInfo).STI = i;
			if(bKeepScores)
			{
				p.PlayerReplicationInfo.Score = ScoreTable[i].Score;
				JCPRI(p.PlayerReplicationInfo).EnemyKillCount = ScoreTable[i].EnemyKills;
				JCPRI(p.PlayerReplicationInfo).FriendKillCount = ScoreTable[i].FriendKills;
				JCPRI(p.PlayerReplicationInfo).DeathCount = ScoreTable[i].Deaths;
				JCPRI(p.PlayerReplicationInfo).SuicideCount = ScoreTable[i].Suicides;
				JCPRI(p.PlayerReplicationInfo).bMute = ScoreTable[i].bMute;
				Log("PostLogin(): Score restored for"@i$":"@p.PlayerReplicationInfo.PlayerName, 'JCoop');
			}
			break;
		}
		i++;
	}
	if(!bInTable && i<ArrayCount(ScoreTable))
	{
		ScoreTable[i].PlayerName = p.PlayerReplicationInfo.PlayerName;
		JCPRI(p.PlayerReplicationInfo).STI = i;
		log("PostLogin(): Score entry added:"@i@ScoreTable[i].PlayerName, 'JCoop');
	}
/*	// not in table, and table full, so find LRU entry to replace
	else
	{
		OldestEntry = 0;
		for(i=0; i<ArrayCount(ScoreTable); i++
		{
			if(ScoreTable[i].LOTime < ScoreTable[OldestEntry].LOTime)
				OldestEntry = i;
		}
		// should we check to see if i is in use by another player?
		ScoreTable[OldestEntry].PlayerName = p.PlayerReplicationInfo.PlayerName;
		JCPRI(p.PlayerReplicationInfo).STI = OldestEntry;
		// zero the score entries
		ScoreTable[OldestEntry].EnemyKills = 0;
		ScoreTable[OldestEntry].FriendKills = 0;
		ScoreTable[OldestEntry].Deaths = 0;
		ScoreTable[OldestEntry].Suicides = 0;
		ScoreTable[OldestEntry].Score = 0;
		ScoreTable[OldestEntry].bMute = false;
		log("PostLogin(): Score entry replaces oldest entry in table:"@i@ScoreTable[OldestEntry].PlayerName, 'JCoop');
	}
*/
	JCPRI(p.PlayerReplicationInfo).bSTIValid = true;
	LogScoreTable();

	Super.PostLogin(p);
} // PostLogin()

// playing with logout() function
function Logout(Pawn Exiting)
{
	local Pawn p;

	if(PlayerPawn(Exiting) != none)
	{
		if(PlayerPawn(Exiting).PlayerReplicationInfo != none)
			log("Logout:"@Exiting.PlayerReplicationInfo.PlayerName@"logging out", 'JCoop');
		else
			log("Logout: Exiting player has no PRI", 'JCoop');

		// search for pawns w/ Exiting as enemy and send them to a new state
		// helps to avoid the server hung @ 100% CPU
		for(p = Level.PawnList; p != none; p = p.NextPawn)
		{
			if(p.IsA('FlockPawn') || p.IsA('FlockMasterPawn') || p.bIsPlayer) continue;
			if(p.Enemy == Exiting)
			{
				log("found a Pawn with me as Enemy!" @ p @ "in state" @ p.GetStateName(), 'JCoop');
				p.Enemy = none;
				if(ScriptedPawn(p) != none)
				{
					if(ScriptedPawn(p).OldEnemy == Exiting)
						ScriptedPawn(p).OldEnemy = none;
					// WhatToDoNext() clears Enemy
					ScriptedPawn(p).WhatToDoNext('Waiting', 'TurnFromWall');
					log("Scripted pawn now 'waiting' 'turnfromwall'", 'JCoop');
				}
				else
				{
					p.GoToState('Idle'); // kludge, but handles the jcannon
					log("Not a scripted pawn. Try send to 'Idle'", 'JCoop');
				}
			}
		}
	}

	// update scoretable timestamp for use in login entries when table full
	ScoreTable[JCPRI(PlayerPawn(Exiting).PlayerReplicationInfo).STI].LOTime = Level.TimeSeconds;

	super.Logout(Exiting);

// find some interesting logout() code in zcoop

} // Logout()

function LogScoreTable()
{
	local int i;

	// post the scoretable to log
	Log("Current Score Table contents:", 'JCoop');
	i=0;
	while(ScoreTable[i].PlayerName != "" && i<ArrayCount(ScoreTable))
	{
		Log("    "$i$":"@ScoreTable[i].PlayerName, 'JCoop');
		i++;
	}
} // LogScoreTable()

// this function is here since the compiler complains that ScoreTable is too big
// when referenced from jPlayerPawn
function UpdateST(PlayerPawn p)
{
	if(p == none)
		return;
	if(JCPRI(p.PlayerReplicationInfo) == none)
		return;

	ScoreTable[JCPRI(p.PlayerReplicationInfo).STI].bMute =
		JCPRI(p.PlayerReplicationInfo).bMute;
}

function ChangeName( Pawn Other, coerce string S, bool bNameChange )
{
	local pawn p;

	if( S == "" ) return;

	if (Other.PlayerReplicationInfo.PlayerName~=S)
		return;
	// must check pawnlist against 'playerpawn' and 'bots' to avoid many accessed
	// nones when starting a listen server (seems SkaarjTrooper gets bIsPlayer=true
	// at startup time :(
	for(p = Level.PawnList; p != none; p = p.NextPawn)
		if(p.bIsPlayer &&
			(p.IsA('PlayerPawn') || (p.IsA('Bots'))) &&
			(p.PlayerReplicationInfo.PlayerName~=S))
		{
			Other.ClientMessage(S$NoNameChange);
			return;
		}

	if(JCPRI(Other.PlayerReplicationInfo).bSTIValid)
		ScoreTable[JCPRI(Other.PlayerReplicationInfo).STI].PlayerName = S;
	if (bNameChange) // from DM
		BroadcastMessage(Other.PlayerReplicationInfo.PlayerName$GlobalNameChange$S, false);
	Other.PlayerReplicationInfo.PlayerName = S;
} // ChangeName()

function Killed(pawn killer, pawn Other, name damageType)
{
	// to prevent the Accessed Nones in killed if Other==None (killed takes
	// care of the case where killer==None). Call ScoreKill here if we don't
	// call killed(), which itself will call ScoreKill() by the end.
	if(Other == none)
		ScoreKill(killer, Other);
	else
		super(UnrealGameInfo).killed(killer, Other, damageType);
} // Killed()

function ScoreKill(pawn Killer, pawn Other)
{
	// seems Other is more often filled than Killer
	// JCoopGame scoring rules
	// DeathCount, KillCount, FriendKillCount, SuicideCount all count up their
	// respective quantities.
	// update PRI and ScoreTable scores + local enemy score

	if((Killer == none) && (Other == none)) return;

	if(Other != None && Other.bIsPlayer)
	{
		if((Killer == Other) || (Killer == none))
		{
			// suicide
			// some penalty for suicide
			JCPRI(PlayerPawn(Other).PlayerReplicationInfo).DeathCount += 1;
			ScoreTable[JCPRI(Other.PlayerReplicationInfo).STI].Deaths += 1;

			Other.PlayerReplicationInfo.Score -= 5;
			ScoreTable[JCPRI(Other.PlayerReplicationInfo).STI].Score -= 5;
			JCPRI(Other.PlayerReplicationInfo).jSpree = 0;

			JCPRI(Other.PlayerReplicationInfo).SuicideCount ++;
			ScoreTable[JCPRI(Other.PlayerReplicationInfo).STI].Suicides += 1;
		}
		else
		{
			Other.DieCount++;
			JCPRI(PlayerPawn(Other).PlayerReplicationInfo).DeathCount += 1;
			ScoreTable[JCPRI(Other.PlayerReplicationInfo).STI].Deaths += 1;
			if((Killer != none) && (PlayerPawn(Killer) == none))
			{
				JCGRI(GameReplicationInfo).SkaarjTotal += 1;
				JCPRI(PlayerPawn(Other).PlayerReplicationInfo).jSpree = 0;
			}
		}
	}

	if(Killer != none && Killer.bIsPlayer)
	{
		Killer.KillCount++;
		if(Other != none)
		{
			if(Other.bIsPlayer || Other.IsA('Nali'))
			{
				JCPRI(Killer.PlayerReplicationInfo).FriendKillCount +=1;
				ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].FriendKills += 1;

				// some penalty for killing friendlies
				Killer.PlayerReplicationInfo.Score -= 2;
				ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].Score =- 2;
				JCPRI(PlayerPawn(Killer).PlayerReplicationInfo).jSpree = 0;
			}
			else if(!Other.IsA('Cow')) // quit scoring cows!
			{
				JCPRI(killer.PlayerReplicationInfo).EnemyKillCount += 1;
				ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].EnemyKills += 1;

				Killer.PlayerReplicationInfo.Score += 1;
				ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].Score += 1;

				JCGRI(GameReplicationInfo).PlayerTotal += 1;
				JCPRI(PlayerPawn(Killer).PlayerReplicationInfo).jSpree += 1;
			}
			else if(Other.IsA('Cow')) // lose a score for cow
			{
/*				Killer.PlayerReplicationInfo.Score -= 1;
				ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].Score -= 1;

				JCPRI(killer.PlayerReplicationInfo).EnemyKillCount -= 1;
				ScoreTable[JCPRI(Killer.PlayerReplicationInfo).STI].EnemyKills -= 1;
*/
				JCPRI(PlayerPawn(Killer).PlayerReplicationInfo).jSpree = 0;
			}
			// tell
			if(Other.IsA('Nali')) // tell the world
				BroadcastMessage(PlayerPawn(Killer).PlayerReplicationInfo.PlayerName @
					"killed" @ Other.GetHumanName());
			else
				jPlayerPawn(killer).ClientMessage("You killed"@Other.GetHumanName());
		}
	}
} // ScoreKill()

// doesn't allow empty string, and checks the new PRI.bMute
function bool CheckAllowsBroadcast( actor broadcaster, int Len )
{
	if(broadcaster==none) return false;
	if(Len==0) return false;
	if(super.AllowsBroadcast(broadcaster, Len))
	{
		if(PlayerPawn(broadcaster) != none)
			return(!JCPRI(PlayerPawn(broadcaster).PlayerReplicationInfo).bMute);
		else
			return true;
	}
	else
		return false;
} // AllowsBroadcast()

// send (and log) a message to admins in the game
function AMsg(string message)
{
	local Pawn p;
	for(p=Level.PawnList; p!=None; p=p.NextPawn) // go thru pawn list
	{
		if(p.bIsPlayer && PlayerPawn(p).bAdmin) // looking for Admins
		{
			PlayerPawn(p).ClientMessage("JCoop:"@message, 'Event', True);
		}
	}
	log(message, 'JCoopAMsg');
} // AMsg()
function AllAMsg(string message)
{
	local Pawn p;
	for(p=Level.PawnList; p!=None; p=p.NextPawn) // go thru pawn list
		if(p.IsA('jPlayerPawn') && jPlayerPawn(p).bAdmin && !jPlayerPawn(p).bTmpAdmin) // looking for Admins
			PlayerPawn(p).ClientMessage("JCoop(FullAdmins):"@message, 'Event', True);
	log(message, 'JCoopFullAMsg');
}


// overridden to take advantage of a summonable jPlayerStart
function NavigationPoint FindPlayerStart( byte Team, optional string incomingName )
{
	local jPlayerStart Dest;
	local int count, i;
	// randomly pick from the available jPlayerStarts (if any)
	// LOL don't place one of these over lava!
	foreach AllActors(class'jPlayerStart', Dest)
		count ++;

	i = 0;
	if(count > 0)
	{
		count = rand(count);
		foreach AllActors(class'jPlayerStart', Dest)
			if(i == count)
				return Dest;
			else
				i++;
	}
	else
		// otherwise use the normal FindPlayerStart()
		return super.FindPlayerStart(Team, incomingName);
} // FindPlayerStart

//=============================================================================
// this command really for use at the game console
exec function who()
{
	local PlayerReplicationInfo PRI;
	local pawn p;
	local int i;

	log(Level.Title @ "Player List:");

/*	ForEach AllActors(class'PlayerReplicationInfo', PRI)
	{
		log(i $ ":" @ PRI.PlayerName @ "ID:" @ JCPRI(PRI).PlayerID @
		"ping:"@PRI.Ping);
		i++;
	}
*/
	for(p = Level.PawnList; p != none; p = p.nextPawn)
		if(p.bIsPlayer && p.PlayerReplicationInfo != none)
			log(p.PlayerReplicationInfo.PlayerName @ "  ID:" $
				JCPRI(p.PlayerReplicationInfo).PlayerID @ "Ping:" $
				p.PlayerReplicationInfo.Ping, 'JCoop');
}

//=============================================================================
// end


// Suff from wiki maybe useful for redacting say strings

static final function string ReplaceText(coerce string Text, coerce string Replace, coerce string With)
{
    local int i;
    local string Output;

    i = InStr(Text, Replace);
    while (i != -1) {
        Output = Output $ Left(Text, i) $ With;
        Text = Mid(Text, i + Len(Replace));
        i = InStr(Text, Replace);
    }
    Output = Output $ Text;
    return Output;
}

// Internal function used for MaskedCompare
// static private final function bool _match(out string mask, out string target)
static final function bool _match(out string mask, out string target)
{
  local string m, mp, cp;
  m = Left(mask, 1);
  while ((target != "") && (m != "*"))
  {
    if ((m != Left(target, 1)) && (m != "?")) return false;
    mask = Mid(Mask, 1);
    target = Mid(target, 1);
        m = Left(mask, 1);
  }
  while (target != "")
  {
        if (m == "*")
    {
      mask = Mid(Mask, 1);
            if (mask == "") return true; // only "*" mask -> always true
            mp = mask;
            cp = Mid(target, 1);
      m = Left(mask, 1);
        }
    else if ((m == Left(target, 1)) || (m == "?"))
    {
            mask = Mid(Mask, 1);
      target = Mid(target, 1);
        m = Left(mask, 1);
        }
    else
    {
            mask = mp;
      m = Left(mask, 1);
            target = cp;
      cp = Mid(cp, 1);
        }
    }
  while (Left(mask, 1) == "*")
  {
        mask = Mid(Mask, 1);
    }
    return (mask == "");
}
// Compare a string with a mask
// Wildcards: * = X chars; ? = 1 char
// Wildcards can appear anywhere in the mask
static final function bool MaskedCompare(coerce string target, string mask, optional bool casesensitive)
{
  if (!casesensitive)
  {
    mask = Caps(mask);
    target = Caps(target);
  }
  if (mask == "*") return true;
  return _match(mask, target);
}
// Make sure that players dont put their Inventory's to BroadcastMessage
function bool AllowsBroadcast( actor broadcaster, int Len )
{
	if( broadcaster.IsA('Inventory') && broadcaster.Owner.IsA('PlayerPawn') &&
	 !PlayerPawn(broadcaster.Owner).bAdmin )
		Return false;
	Return CheckAllowsBroadcast(broadcaster,Len);
}
function ListMeBanned( jPlayerPawn Other )
{
	local int i;
	local string FullAddr;
	
	if( !Other.bAdmin )
		Return;
	for(i=0; i<ArrayCount(BannedIPs); i++)
	{
		if( BannedIPs[i].Nr1!=0 || BannedIPs[i].Nr2!=0 || BannedIPs[i].Nr3!=0 || BannedIPs[i].Nr4!=0 )
		{
			FullAddr = BannedIPs[i].Nr1$"."$BannedIPs[i].Nr2$"."$BannedIPs[i].Nr3$"."$BannedIPs[i].Nr4;
			Other.ClientMessage("IP"@i+1$":"@FullAddr@"="@BannedIPs[i].BannedName);
		}
	}
}
function RemoveBann( jPlayerPawn Other, int Slot )
{
	local string FullAddr;
	
	Slot--;
	if( Slot<0 || Slot>ArrayCount(BannedIPs) )
	{
		Other.ClientMessage("Slot"@Slot+1@"dosent exist");
		Other.ClientMessage("Select between 0-"$ArrayCount(BannedIPs)+1);
		Return;
	}
	if( !Other.bAdmin || Other.bTmpAdmin ) Return;
	if( BannedIPs[Slot].Nr1!=0 || BannedIPs[Slot].Nr2!=0 || BannedIPs[Slot].Nr3!=0 ||
	 BannedIPs[Slot].Nr4!=0 )
	{
		FullAddr = BannedIPs[Slot].Nr1$"."$BannedIPs[Slot].Nr2$"."$BannedIPs[Slot].Nr3$"."$
		BannedIPs[Slot].Nr4;
		AMsg(FullAddr@"("$BannedIPs[Slot].BannedName$") has been forgiven by"@Other.GetHumanName());
		Log(FullAddr@"("$BannedIPs[Slot].BannedName$") has been forgiven by"@Other.GetHumanName(),'RemoveBann');
		BannedIPs[Slot].Nr1=0;
		BannedIPs[Slot].Nr2=0;
		BannedIPs[Slot].Nr3=0;
		BannedIPs[Slot].Nr4=0;
		BannedIPs[Slot].BannedName="";
		SaveConfig();
	}
	else
		Other.ClientMessage("Slot"@Slot+1@"is not even banned");
}
function bool DoBann( jPlayerPawn Other, int ID )
{
	local Pawn P;
	local int i;
	
	for( P=Level.PawnList; P!=None; P=P.nextPawn )
	{
		if( P.IsA('jPlayerPawn') && JCPRI(P.PlayerReplicationInfo).PlayerID==ID )
		{
			if( jPlayerPawn(P).Player.Console!=None )
			{
				Other.ClientMessage("Unable to bann Listen Server Host");
				Return True;
			}
			for(i=0; i<ArrayCount(BannedIPs); i++)
			{
				if( BannedIPs[i].Nr1==0 && BannedIPs[i].Nr2==0 && BannedIPs[i].Nr3==0 &&
				 BannedIPs[i].Nr4==0 )
				{
					BannedIPs[i].Nr1 = jPlayerPawn(P).MyIP.Nr1;
					BannedIPs[i].Nr2 = jPlayerPawn(P).MyIP.Nr2;
					BannedIPs[i].Nr3 = jPlayerPawn(P).MyIP.Nr3;
					BannedIPs[i].Nr4 = jPlayerPawn(P).MyIP.Nr4;
					BannedIPs[i].BannedName = P.PlayerReplicationInfo.PlayerName;
					Other.jSay("Banned"@P.PlayerReplicationInfo.PlayerName$"'s IP");
					Log(Other.GetHumanName()@"banned"@P.PlayerReplicationInfo.PlayerName,'DoBann');
					Other.kickid(string(ID));
					SaveConfig();
					Return True;
				}
			}
			Other.ClientMessage("Banned list is FULL");
			Return True;
		}
	}
	Return False;
}
function Tick( float DeltaTime )
{
	local ScriptedPawn p;
	if( bShowDownloaders )
	{
		ReCheckDLers+=DeltaTime;
		if( ReCheckDLers>=7 )
		{
			if( bGetDLSHIT() )
				ReCheckDLers=6;
			else ReCheckDLers=0;
		}
	}
}
function bool bGetDLSHIT()
{
	local string S,S2,S3,DoneS,MaxS;
	local int i,i2,i3,Tries,MaxSize,Decimal;
	local float Done;
	local string IPs[4],Files[4],CurrentIP,DownloaderName[4];

	S2 = ConsoleCommand("Sockets");
	while( InStr(S2, "Client ") >= 0 )
	{
		CurrentIP = Mid(S2,InStr(S2, "Client ")+7);
		S = Mid(S2,InStr(S2, "Client ")+7);
		CurrentIP = Left(S,InStr(S, " "));
		if( InStr(S, "Client ") >= 0 )
			S = Left(S,InStr(S, "Client "));
		if( InStr(S, "File=") >= 0 )
		{
			while( InStr(S, "File=") >= 0 )
				S = Mid(S,InStr(S, "File=")+6);
			if( i2<=3 )
			{
				S = Left(S,InStr(S, " closing"));
				S3 = Left(S,InStr(S, "'"));
				S = Mid(S,InStr(S, " Sent=")+6);
				DoneS = Left(S,InStr(S, "/"));
				Done = int(DoneS);
				MaxS = Mid(S,InStr(S, "/")+1);
				MaxSize = int(MaxS);
				Done = (Done/MaxSize)*100;
				MaxSize /= 1000;
				if( Done>=10 )
					Decimal = int(Mid(String(Done),3));
				else if( Done<10 ) Decimal = int(Mid(String(Done),2));
				else Decimal = int(Mid(String(Done),4));
				Decimal = int(Left(String(Done),1));
				if( String(int(Done))~="100" )
					Files[i2] = "Successfully received '"$S3$"' ("$MaxSize@"kb)";
				Files[i2] = "Receiving '"$S3$"' "@int(Done)$","$Decimal$"% ("$MaxSize@"kb)";
				IPs[i2] = CurrentIP;
				i3 = LastJoin+1;
				while( Tries<=52 && Joiners[i3].IPAddress!=CurrentIP )
				{
					Tries++;
					i3--;
					if( i3<0 )
						i3 = ArrayCount(Joiners)-1;
				}
				if( Joiners[i3].IPAddress~=CurrentIP )
					DownloaderName[i2] = Joiners[i3].PlayerName;
				else DownloaderName[i2] = "-(Unknown player)-";
			}
			i2++;
		}
		S2 = Mid(S2,InStr(S2, "Client ")+7);
	}
	JCGRI(GameReplicationInfo).NumDownloaders = i2;
	for (i = 0; i< 4; i++)
	{
		if( DownloaderName[i]!="" )
			JCGRI(GameReplicationInfo).Downloaders[i]=DownloaderName[i]$":"@Files[i];
		else JCGRI(GameReplicationInfo).Downloaders[i]="";
	}
	if( bHasReported && i2==0 )
	{
		BroadcastMessage("No more downloaders!",true,'LowCriticalEvent');
		bHasReported=false;
	}
	else if( !bHasReported && i2>0 )
	{
		BroadcastMessage("WARNING:"@DownloaderName[0]@"started to download",true,'RedCriticalEvent');
		bHasReported=true;
	}
}

defaultproperties
{
				MaxSuicides=10
				LoginDenyPeriod=10.000000
				bShowDownloaders=True
				bShowAdmins=True
				bCoopScore=True
				bAdvLead=True
				ServerTravelPause=3
				GlobalNameChange=" changed name to "
				NoNameChange=" is already in use"
				RapidLoginMessage="Please don't repeat logins so rapidly - "
				KeepoutMessage="You have misbehaved and are currently kept out of this server"
				NoNameMessage="Please enter a player name before joining this server"
				AdvJC="[J5b3]"
				DefaultPlayerClass=Class'KNR.jFemaleTwo'
				ScoreBoardType=Class'KNR.JCScoreBoard'
				GameMenuType=None
				BotMenuType=""
				RulesMenuType="jCoop5Menu.jCoopGameRulesSClient"
				SettingsMenuType="jCoop5Menu.jCoopGameSettingsSClient"
				HUDType=Class'KNR.jHUD'
				GameReplicationInfoClass=Class'KNR.JCGRI'
}
